/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_SurfaceWrapOp_h__
#define __operator_SurfaceWrapOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to update an attached surface to follow a driving surface

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT SurfaceWrapOp:
	public SurfaceBindOp,
	public Initialize<SurfaceWrapOp>,
	public ObjectSafe<SurfaceWrapOp>
{
	public:

					SurfaceWrapOp(void)										{}
virtual				~SurfaceWrapOp(void)									{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,Range a_range);

	private:

		sp<SurfaceAccessibleI>			m_spInputAccessible;
		sp<SurfaceAccessibleI>			m_spOutputAccessible;
		sp<SurfaceAccessibleI>			m_spDriverAccessible;
		sp<SurfaceAccessibleI>			m_spDeformedAccessible;
		sp<SurfaceI>					m_spDriver;
		sp<SurfaceI>					m_spDeformed;
		sp<DrawI>						m_spDrawI;
		sp<DrawMode>					m_spDebugGroup;
		String							m_faceName;
		String							m_baryName;
		SurfaceAccessibleI::Element		m_element;
		SurfaceAccessibleI::Attribute	m_attribute;
};

} /* namespace */

#endif /* __operator_SurfaceWrapOp_h__ */
