/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessorI_h__
#define __surface_SurfaceAccessorI_h__

namespace fe
{

/**************************************************************************//**
	@brief Surface Element Handle

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessorI: virtual public Component
{
	public:
virtual	U32				count(void) const									=0;
virtual	U32				subCount(U32 index) const							=0;

virtual	void			set(U32 index,I32 a_integer)						=0;
virtual	void			set(U32 index,U32 subIndex,I32 a_integer)			=0;
virtual	I32				integer(U32 index,U32 subIndex=0)					=0;

virtual	void			set(U32 index,Real a_real)							=0;
virtual	void			set(U32 index,U32 subIndex,Real a_real)				=0;
virtual	Real			real(U32 index,U32 subIndex=0)						=0;

virtual	void			set(U32 index,const SpatialVector& a_vector)		=0;
virtual	void			set(U32 index,U32 subIndex,
								const SpatialVector& a_vector)				=0;
virtual	SpatialVector	spatialVector(U32 index,U32 subIndex=0)				=0;

						/// @brief Set an attribute
/*
virtual void			append(void)										=0;
virtual void			remove(void)										=0;
*/
};

} // namespace

#endif /* __surface_SurfaceAccessorI_h__ */
