/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "grass/grass.pmh"

using namespace fe;

int main(void)
{
	UNIT_START();
	BWORD completed=FALSE;

	try
	{
		Blade blade;
		std::vector<SpatialVector>& rTangent=blade.tangent();
		std::vector<SpatialVector>& rLocation=blade.location();
		std::vector<Real>& rVelocity=blade.velocity();

		rTangent.resize(1);
		set(rTangent[0],1.0,0.0,0.0);

		rLocation.resize(5);
		for(U32 m=0;m<5;m++)
		{
			set(rLocation[m],0.0,m,0.0);
		}

		rVelocity.resize(4);
		for(U32 m=0;m<4;m++)
		{
			rVelocity[m]=0.0;
		}

		for(U32 n=0;n<1e6;n++)
		{
			feLog("\n");

			blade.step(0);
			for(U32 m=0;m<5;m++)
			{
				feLog("location %s  velocity %.6G\n",
						c_print(rLocation[m]),m? rVelocity[m-1]: 0.0);
			}

			if(true)
			{
				for(I32 m=3;m>=0;m--)
				{
					for(I32 n=3;n>=0;n--)
					{
						Real along=n/4.0;
						Real between=along*rLocation[m+1][0]+
								(1.0-along)*rLocation[m][0];
						feLog("%*s#\n",int((between+4.0)*10)," ");
					}
				}
			}
		}

		completed=TRUE;
	}
	catch(Exception &e)	{ e.log(); }
	catch(...)			{ feLog("uncaught exception\n"); }

	UNIT_TEST(completed);
	UNIT_TRACK(1);
	UNIT_RETURN();
}
